#!/usr/bin/env node

var exec = require('child_process').exec,
path = require('path'),
fs = require('fs'),
sife = require('../lib/sife'),
sifeConfig = null;

var commands = {
	server: function() {
		if (process.argv[3] === 'start') {

			var styleguidePath = path.resolve(__dirname, '../') + '/styleguide';

			var childProcess = exec('node ' + styleguidePath + '/server.js');

			childProcess.stdout.on('data', function (d) {
				console.log(d);
			});
			childProcess.stderr.on('data', function (d) {
				console.log(d);
			});

		}
	},

	component: function() {
		if (process.argv[3] === 'start') {
			require('./lib/component-start').start(sifeConfig);
		}
	},

	build: function(){
		//build all the things
		sife.init(sifeConfig);
		sife.build();
	},

	transpile: function(){
		//transpile all the things
		sife.init(sifeConfig);
		sife.transpile();
	},

	version: function(){
		sife.getVersion();
	}
};

if(['help', '-help', '--help','-h', '--h'].indexOf(process.argv[2]) > -1 ){
	console.log('help is coming...');
	return;
}

if(['version', '-version', '--version','-v', '--v'].indexOf(process.argv[2]) > -1 ){
	commands.version();
	return;
}

if (commands[process.argv[2]]) {

	// first things first, get the Sife.json config
	sifeConfig = require('../lib/loadConfig.js')();

	commands[process.argv[2]]();
} else {
	console.log('Error: your arguments are invalid 😓');
}



